SystemOrganization addCategory: #'ElasticSearch-Core'!

Object subclass: #ESDocumentId
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDocumentId commentStamp: 'PaulDeBruicker 4/24/2013 10:13' prior: 0!
Used to create "unique" ids for documents.  Elasticsearch will do it automatically if you leave the id field blank when indexing a document!

!ESDocumentId class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 14:54'!
defaultIdStrategy
	^ ESDocumentIdUUIDStrategy! !

!ESDocumentId class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 14:48'!
newId
	^ self defaultIdStrategy new! !

Object subclass: #ESDocumentIdUUIDStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDocumentIdUUIDStrategy commentStamp: 'PaulDeBruicker 4/24/2013 10:12' prior: 0!
Use this if you want to create your own UUIDs to use as ids for your documents. !

!ESDocumentIdUUIDStrategy class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 14:53'!
new
	^ UUID new! !

Object subclass: #ESDocumentIdUnixSecondsStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDocumentIdUnixSecondsStrategy commentStamp: 'PaulDeBruicker 4/24/2013 10:12' prior: 0!
Use this if you want to create your own timestamps to use as ids for your documents. !

!ESDocumentIdUnixSecondsStrategy class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 14:50'!
new
	^ DateAndTime now asUnixTime! !

Object subclass: #ESHTTPClient
	instanceVariableNames: 'client'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESHTTPClient class
	instanceVariableNames: 'default'!

!ESHTTPClient commentStamp: 'PaulDeBruicker 4/24/2013 10:11' prior: 0!
This class only exists because I'm going to port the package to Squeak and as far as I know Squeak doesn't use Zinc but instead uses WebClient and somebody will have to change all the HTTP client stuff!

ESHTTPClient class
	instanceVariableNames: 'default'!

!ESHTTPClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:27'!
defaultHostName
	^ 'localhost'! !

!ESHTTPClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 20:34'!
defaultHttpClient
	^ ESZnClient! !

!ESHTTPClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:27'!
defaultPort
	^ 9200! !

!ESHTTPClient class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 20:34'!
httpClient
	^ default ifNil: [ default := self defaultHttpClient new ]! !

!ESHTTPClient methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:37'!
client
	^ client ifNil: [ client := self defaultClient new ]! !

!ESHTTPClient methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 09:59'!
defaultUrl
	self subclassResponsibility! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:09'!
delete: aZnUrl 
^	self client delete: aZnUrl url! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:07'!
get: aUrl
	^ self client get: aUrl url! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
get: aUrl data: aByteString
	^ self client get: aUrl url contents: aByteString! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
head: aUrl
	^ self client head: aUrl url! !

!ESHTTPClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:26'!
hostName
	^ self class defaultHostName! !

!ESHTTPClient methodsFor: 'testing' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
indexExistsAt: aUrl
	^ (self client headResponseStatusFor: aUrl url) = 200! !

!ESHTTPClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:26'!
port
	^ self class defaultPort! !

!ESHTTPClient methodsFor: 'http-method' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
post: aUrl data: aByteString
	^ self client post: aUrl url contents: aByteString! !

!ESHTTPClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
put: url data: someData
	^ self client put: url url contents: someData! !

!ESHTTPClient methodsFor: 'testing' stamp: 'PaulDeBruicker 4/24/2013 10:08'!
typeExistsAt: aUrl
	^ (self client headResponseStatusFor: aUrl url) = 200! !

!ESHTTPClient methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 09:55'!
url
	^ self defaultUrl new! !

ESHTTPClient subclass: #ESZnClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESZnClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:00'!
baseUrl
	^ self url
		host: self hostName;
		port: self port;
		yourself! !

!ESZnClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:37'!
defaultClient
	^ ZnClient! !

!ESZnClient methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 09:59'!
defaultUrl
	^ ESZnUrl! !

Object subclass: #ESObject
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

ESObject subclass: #ESDocument
	instanceVariableNames: 'id version index type content created modified parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESDocument class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 4/22/2013 17:25'!
fromJson: aJsonObject 
	|newDocument|
	newDocument :=self new.
	newDocument id: (aJsonObject at:'_id');
	type: (aJsonObject at:'_type');
	version: (aJsonObject at:'_version');
	content:(aJsonObject at:'_source') asDictionary.
	^newDocument ! !

!ESDocument class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 4/22/2013 17:32'!
fromJson: aJsonObject inIndex: anESIndex
	^ self new parseContentFromJson: aJsonObject fromIndex: anESIndex! !

!ESDocument class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/22/2013 15:02'!
ofType: aType withContent: aDictionaryOfDocumentContent
	^ self new
		type: aType;
		content: aDictionaryOfDocumentContent;
		yourself! !

!ESDocument class methodsFor: 'testing' stamp: 'PaulDeBruicker 4/22/2013 15:14'!
setIdInClient
	^false! !

!ESDocument class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/22/2013 15:01'!
withContent: aDictionaryOfDocumentContent
	^ self new
		content: aDictionaryOfDocumentContent;
		yourself! !

!ESDocument methodsFor: 'comparing' stamp: 'PaulDeBruicker 4/22/2013 17:16'!
= anObject
	"Answer whether the receiver and anObject represent the same object."

	self == anObject
		ifTrue: [ ^ true ].
	self class = anObject class
		ifFalse: [ ^ false ].
	^ content = anObject content and: [ id = anObject id1 ]! !

!ESDocument methodsFor: 'indexing' stamp: 'PaulDeBruicker 4/23/2013 15:02'!
addToIndex: anESIndex
	| response json |
	self index: anESIndex.
	response := self hasId
		ifTrue: [ self httpClient put: self urlForIndexing data: self messageJsonContent ]
		ifFalse: [ self httpClient post: self urlForIndexing data: self messageJsonContent ].
	json := self parseJsonFromString: response.
	self
		ifResponse: json
		isNotErrorThenDo: [ :someJson | 
			(someJson at: 'ok')
				ifTrue: [ 
					self id: (someJson at: '_id').
					self version: (someJson at: '_version') asNumber ] ]! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 15:14'!
content
	
	^ content! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:28'!
content: aDictionary
	content := aDictionary.
	self updateModifiedTime! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:30'!
created
	^ created! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:38'!
created: aDateAndTime 
	
	created := aDateAndTime! !

!ESDocument methodsFor: 'testing' stamp: 'PaulDeBruicker 4/23/2013 17:37'!
hasId
	^ self id notEmpty! !

!ESDocument methodsFor: 'testing' stamp: 'PaulDeBruicker 4/23/2013 14:46'!
hasVersion
	^ self version notNil! !

!ESDocument methodsFor: 'comparing' stamp: 'PaulDeBruicker 4/22/2013 17:16'!
hash
	"Answer an integer value that is related to the identity of the receiver."

	^ content hash bitXor: id hash! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 15:12'!
id
	
	 id isNil ifTrue: [self setId] .
	
	^id! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:16'!
id1
	^ id! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:11'!
id: aByteString 
	
	id := aByteString! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:00'!
index
	
	^ index! !

!ESDocument methodsFor: 'ids' stamp: 'PaulDeBruicker 4/22/2013 16:41'!
index: anIndex
	index := anIndex! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:36'!
initialize
	super initialize.
	created := DateAndTime now.
	self updateModifiedTime.
	content := Dictionary new! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:30'!
messageJsonContent
	self content at: 'created' put: self created.
	self content at: 'modified' put: self modified.
	^ self content asJsonString! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:30'!
modified
	^ modified! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:37'!
modified: aDateAndTime 
	
	modified := aDateAndTime! !

!ESDocument methodsFor: 'ids' stamp: 'PaulDeBruicker 4/23/2013 14:54'!
newId
	^ ESDocumentId newId! !

!ESDocument methodsFor: 'parsing' stamp: 'PaulDeBruicker 4/22/2013 17:40'!
parseContentFromJson: aJsonObject fromIndex: anESIndex
	| data |
	self
		id: (aJsonObject at: '_id');
		index: anESIndex;
		type: (aJsonObject at: '_type');
		version: (aJsonObject at: '_version').
	(aJsonObject at: '_source') asDictionary
		keysAndValuesDo: [ :selector :value | 
			| newValue |
			newValue := value.
			(selector = 'created' or: [ selector = 'modified' ])
				ifTrue: [ 
					newValue := DateAndTime fromString: value.
					self perform: (selector , ':') asSymbol withArguments: (Array with: newValue) ].
			self content at: selector put: newValue ]! !

!ESDocument methodsFor: 'ids' stamp: 'PaulDeBruicker 4/22/2013 15:17'!
setId
	id := self setIdInClient
		ifTrue: [ self newId ]
		ifFalse: [ String new ]! !

!ESDocument methodsFor: 'testing' stamp: 'PaulDeBruicker 4/22/2013 15:14'!
setIdInClient
	^self class setIdInClient ! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 15:11'!
type
	
	^ type ifNil:['noType']! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:25'!
type: aByteString 
	
	type := aByteString! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:29'!
updateModifiedTime
	modified := DateAndTime now! !

!ESDocument methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:04'!
urlForIndexing
	^ self baseUrl
		addToPath: self index name;
		addToPath: self type;
		addToPath: self id! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 14:46'!
version
	^ version! !

!ESDocument methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/22/2013 17:11'!
version: aSmallInteger 
	
	version := aSmallInteger! !

ESObject subclass: #ESIndex
	instanceVariableNames: 'shards replicas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESIndex class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 20:31'!
createIndex: anIndexName
	^ self new createIndexNamed: anIndexName! !

!ESIndex class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:35'!
deleteIndex: anIndexName
	^ self new deleteIndexNamed: anIndexName! !

!ESIndex class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 17:33'!
indexNamed: aName
	^ self new
		name: aName;
		ensureExistence;
		yourself! !

!ESIndex methodsFor: 'documents' stamp: 'PaulDeBruicker 4/23/2013 17:28'!
addDocument: anESDocument
	anESDocument addToIndex: self! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 4/23/2013 15:10'!
createIndexNamed: aName
	| response |
	self name: aName.
	response := self parseJsonFromString: (self httpClient put: self url data: self shardsAndReplicaSettings).
	self ifResponse: response isNotErrorThenDo: [:someJson | nil ]! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 4/23/2013 15:10'!
deleteIndexNamed: aName
	^ aName notEmpty
		ifTrue: [ 
			| response |
			self name: aName.
			response := self parseJsonFromString: (self httpClient delete: self url).
			self ifResponse: response isNotErrorThenDo: [ :someJson | nil ] ]
		ifFalse: [ Error signal: 'you are trying to delete all the indicies' ]! !

!ESIndex methodsFor: 'actions' stamp: 'PaulDeBruicker 4/23/2013 17:33'!
ensureExistence
	self indexExists
		ifFalse: [ self createIndexNamed: self name ]! !

!ESIndex methodsFor: 'documents' stamp: 'PaulDeBruicker 4/22/2013 17:26'!
getDocument: anESDocument
	| response |
	response := self parseJsonFromString: (self httpClient get: (self urlToGetDocument: anESDocument)).
	^ ESDocument fromJson: response inIndex: self! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 4/24/2013 10:04'!
getSettings
	| settings |
	settings := self parseJsonFromString: (self httpClient get: (self url addToPath: '_settings')).
	shards := (((settings at: self name) at: 'settings') at: 'index.number_of_shards') asNumber.
	replicas := (((settings at: self name) at: 'settings') at: 'index.number_of_replicas') asNumber! !

!ESIndex methodsFor: 'testing' stamp: 'PaulDeBruicker 4/23/2013 13:40'!
indexExists
	^ self httpClient indexExistsAt: self url! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 4/21/2013 21:19'!
initialize
	super initialize.
	shards := 1.
	replicas := 1! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
replicas
	^ replicas! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
replicas: anObject
	replicas := anObject! !

!ESIndex methodsFor: 'search' stamp: 'PaulDeBruicker 4/22/2013 21:22'!
searchFor: aQuery
	^ self httpClient get: aQuery searchUrl! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/23/2013 11:28'!
searchUrl
	^ self searchUrlForType: ''! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:04'!
searchUrlForType: aType
	| url |
	url := self url.
	aType notEmpty
		ifTrue: [ url addToPath: aType ].
	url addToPath: '_search'.
	^ url! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
shards
	^ shards! !

!ESIndex methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
shards: anObject
	shards := anObject! !

!ESIndex methodsFor: 'initialization' stamp: 'PaulDeBruicker 4/21/2013 21:45'!
shardsAndReplicaSettings
	^ (self shards = 1 and: [ self replicas = 1 ])
		ifTrue: [ String new ]
		ifFalse: [ 
			| dict |
			dict := Dictionary new.
			dict at: 'shards' put: self shards.
			dict at: 'replicas' put: self replicas.
			'Settings' -> dict ]! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:04'!
statusUrl
	^ self baseUrl addToPath: '_status'! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:05'!
url
	^ self baseUrl addToPath: self name! !

!ESIndex methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 10:05'!
urlToGetDocument: anESDocument
	^ self baseUrl
		addToPath: self name;
		addToPath: anESDocument type;
		addToPath: anESDocument id! !

!ESObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/21/2013 21:23'!
baseUrl
	^ self httpClient baseUrl! !

!ESObject methodsFor: 'json' stamp: 'PaulDeBruicker 4/23/2013 15:07'!
errorMessageFor: aJsonObject 
^	aJsonObject at:'error'! !

!ESObject methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 13:40'!
httpClient
	^ ESHTTPClient httpClient! !

!ESObject methodsFor: 'json' stamp: 'PaulDeBruicker 4/23/2013 15:03'!
ifResponse: someJson isNotErrorThenDo: aBlock
	(self responseIsError: someJson)
		ifTrue: [ Error signal: (self errorMessageFor: someJson) ]
		ifFalse: [ aBlock value: someJson ]! !

!ESObject methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
name
	^ name
! !

!ESObject methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/21/2013 21:20'!
name: anObject
	name := anObject! !

!ESObject methodsFor: 'json' stamp: 'PaulDeBruicker 4/22/2013 14:31'!
parseJsonFromString: aString
	^ Json readFrom: aString readStream! !

!ESObject methodsFor: 'json' stamp: 'PaulDeBruicker 4/23/2013 14:59'!
responseIsError: someJson
	^ (someJson at: 'error') notNil! !

ESObject subclass: #ESQuery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESQuery commentStamp: 'PaulDeBruicker 4/24/2013 10:16' prior: 0!
Elasticesearch uses a big QueryDSL to fine tune searching.  Its not implemented in this client at all yet.  !

ESObject subclass: #ESQueryStringQuery
	instanceVariableNames: 'field queryString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESQueryStringQuery class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 11:19'!
forString: aString
	^ self new
		queryString: aString;
		yourself! !

!ESQueryStringQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 13:07'!
asJsonString
	| d1 d2 d3 |
	d1 := Dictionary new.
	d1 at: 'query' put: self queryString.
	d2 := Dictionary new.
	d2 at: 'query_string' put: d1.
	d3 := Dictionary new.
	d3 at: 'query' put: d2.
	^ d3 asJsonString! !

!ESQueryStringQuery methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 11:46'!
asQueryString
	^ 'q=' , self queryString! !

!ESQueryStringQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:22'!
queryString
	^ queryString! !

!ESQueryStringQuery methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:22'!
queryString: anObject
	queryString := anObject! !

ESObject subclass: #ESSearch
	instanceVariableNames: 'index query results'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESSearch commentStamp: 'PaulDeBruicker 4/24/2013 10:18' prior: 0!
Basic implementation of searching using the QueryDSL.  Right now it only searches for query strings and does not implement any of the other  refinements mentioned here:

http://www.elasticsearch.org/guide/reference/query-dsl/!

!ESSearch class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 11:17'!
index: anESIndex
	^ self new
		index: anESIndex;
		yourself! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
index
	^ index! !

!ESSearch methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
index: anESIndex
	index := anESIndex! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
query
	^ query! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
query: anObject
	query := anObject! !

!ESSearch methodsFor: 'string-searches' stamp: 'PaulDeBruicker 4/23/2013 11:18'!
queryString: aString
	query := ESQueryStringQuery forString: aString! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
results
	^ results! !

!ESSearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/23/2013 11:29'!
results: anObject
	results := anObject! !

!ESSearch methodsFor: 'actions' stamp: 'PaulDeBruicker 4/23/2013 15:04'!
search
	| response |
	response := self parseJsonFromString: (self httpClient get: self index searchUrl data: self query asJsonString).
	self ifResponse: response isNotErrorThenDo: [ :someJson | self setResultsFrom: someJson ]! !

!ESSearch methodsFor: 'actions' stamp: 'PaulDeBruicker 4/23/2013 13:29'!
setResultsFrom: response
	results := ((response at: 'hits') at: 'hits')
		collect: [ :eachJsonDocument | ESDocument fromJson: eachJsonDocument inIndex: self index ]! !

ESSearch subclass: #ESURISearch
	instanceVariableNames: 'uriParameters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESURISearch commentStamp: 'PaulDeBruicker 4/24/2013 10:17' prior: 0!
To search you need to specify an index you wish to search and then some search criteria.  You can refine the search by 'type' which limits elasticsearch to only search for documents of the specified type.  Each of the 'parameters' are described here:

http://www.elasticsearch.org/guide/reference/api/search/uri-request/!

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:44'!
analyzeWildcard: anObject
	"Should wildcard and prefix queries be analyzed or not. Defaults to false."

	self uriParameters at: 'analyze_wildcard' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:44'!
analyzer: anObject
	"The analyzer name to be used when analyzing the query string."

	self uriParameters at: 'analyzer' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:45'!
defaultField: anObject
	"The default field to use when no field prefix is defined within the query."

	self uriParameters at: 'df' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:45'!
defaultOperator: anObject
	"The default operator to be used, can be AND or OR. Defaults to OR."

	self uriParameters at: 'default_operator' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:45'!
explain: anObject
	"For each hit, contain an explanation of how scoring of the hits was computed."

	self uriParameters at: 'explain' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:45'!
fields: anObject
	"The selective fields of the document to return for each hit (either retrieved from the index if stored, or from the _source if not), comma delimited. Defaults to the internal _source field. Not specifying any value will cause no fields to return."

	self uriParameters at: 'fields' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
from: anObject
	"The starting from index of the hits to return. Defaults to 0."

	self uriParameters at: 'from' put: anObject! !

!ESURISearch methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 4/24/2013 07:42'!
initialize
	super initialize.
	uriParameters := Dictionary new.
	uriParameters at: 'q' put: 'no query'! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:47'!
lowercaseExpandedTerms: anObject
	"Should terms be automatically lowercased or not. Defaults to true."

	self uriParameters at: 'lowercase_expanded_terms' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:44'!
queryString: aString
	"The query string (maps to the query_string query, see Query String Query for more details)."

	self uriParameters at: 'q' put: aString! !

!ESURISearch methodsFor: 'urls' stamp: 'PaulDeBruicker 4/24/2013 07:48'!
queryUrl
	| url |
	url := self index searchUrl.
	self uriParameters keysAndValuesDo: [ :queryKey :queryValue | url queryAt: queryKey put: queryValue ].
	^ url! !

!ESURISearch methodsFor: 'search' stamp: 'PaulDeBruicker 4/24/2013 07:33'!
search
	| response |
	response := self parseJsonFromString: (self httpClient get: self queryUrl).
	self ifResponse: response isNotErrorThenDo: [ :someJson | self setResultsFrom: someJson ]! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:47'!
searchType: anObject
	"The type of the search operation to perform. Can be dfs_query_then_fetch, dfs_query_and_fetch, query_then_fetch, query_and_fetch, count, scan. Defaults to query_then_fetch. See Search Type for more details on the different types of search that can be performed."

	self uriParameters at: 'search_type' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
size: anObject
	"The number of hits to return. Defaults to 10."

	self uriParameters at: 'size' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
sort: anObject
	"Sorting to perform. Can either be in the form of fieldName, or fieldName:asc/fieldName:desc. The fieldName can either be an actual field within the document, or the special _score name to indicate sorting based on scores. There can be several sort parameters (order is important)."

	self uriParameters at: 'sort' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
timeout: anObject
	"A search timeout, bounding the search request to be executed within the specified time value and bail with the hits accumulated up to that point when expired. Defaults to no timeout."

	self uriParameters at: 'timeout' put: anObject! !

!ESURISearch methodsFor: 'parameters' stamp: 'PaulDeBruicker 4/24/2013 07:46'!
trackScores: anObject
	"When sorting, set to true in order to still track scores and return them as part of each hit."

	self uriParameters at: 'track_scores' put: anObject! !

!ESURISearch methodsFor: 'accessing' stamp: 'PaulDeBruicker 4/24/2013 08:01'!
uriParameters
	
	^ uriParameters! !

ESObject subclass: #ESType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

Object subclass: #ESUrl
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESUrl commentStamp: 'PaulDeBruicker 4/24/2013 10:11' prior: 0!
This class only exists because I'm going to port it to Squeak and as far as I know Squeak doesn't use Zinc but instead uses WebClient and somebody will have to change all the HTTP client stuff!

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:05'!
addToPath: aPath
	self url addPathSegment: aPath! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:01'!
defaultUrl
	self subclassResponsibility! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:01'!
host: aHostname
	self url host: aHostname! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:02'!
port: aHostname
	self url port: aHostname! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:02'!
queryAt: aKey put: aValue
	self url queryAt: aKey put: aValue! !

!ESUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:00'!
url
	^ url ifNil: [ url := self defaultUrl new ]! !

ESUrl subclass: #ESZnUrl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ElasticSearch-Core'!

!ESZnUrl methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 4/24/2013 10:01'!
defaultUrl
	^ ZnUrl! !
